__author__ = "ardevelop"

import escape


def textbox(model, *fields):
    name = model.prefix + ".".join(fields)
    value = model.get(*fields) or ""
    return '<input type="text" class="textbox" name="' + name + '" value="' + escape.utf8(value) + '"/>'


def hidden(model, *fields):
    name = model.prefix + ".".join(fields)
    value = model.get(*fields) or ""
    return '<input type="hidden" name="' + name + '" value="' + escape.utf8(value) + '"/>'


def textarea(model, *fields):
    name = model.prefix + ".".join(fields)
    value = model.get(*fields) or ""
    return '<textarea class="textbox" name="' + name + '">' + escape.utf8(value) + '</textarea>'


def dropdown(options, model, *fields):
    name = model.prefix + ".".join(fields)
    value = model.get(*fields) or ""
    options = [
        '<option value="' + escape.utf8(val) + '"' + ('selected="selected"' if val == value else '') + '>' + escape.utf8(text) + '</option>'
        for val, text in options.iteritems()]

    return '<select data-control="dropdown" name="' + name + '">' + "".join(options) + '</select>'